
------------------------------
-- Combo Point Widget
------------------------------

--[[

	- Proc Widget

/run print(UnitAffectingCombat("target"))
/run print(UnitCreatureFamily("target"), UnitCreatureType("target"))
--]]
local TidyPlatesComboWidgetFrame

local comboWidgetPath = "Interface\\Addons\\TidyPlatesWidgets\\ComboWidget\\"
local artpath = "Interface\\Addons\\TidyPlatesWidgets\\ComboWidget\\"
local artfile = artpath.."RogueMax8.tga"
local grid = .0625
local monkOffset = 10

local maxComboPoints = 0

local WidgetList = {}

local function GetDruidPoints()
	local points = GetComboPoints("player", "target")

	return points
end

local function GetRoguePoints()
	local points = GetComboPoints("player", "target")

--[[
	if points and points > 0 then

		-- Anticipation
		if points > 4 then
			local name, _, _, count = UnitAura("player", Anticipation)

			if name and count > 0 then
				points = points + count
			end
		end
	end
	--]]

	return points
end

local function GetPaladinPoints()
	local points = UnitPower("player", SPELL_POWER_HOLY_POWER)

	if points > 0 then points = points + monkOffset end
	return points
end

local function GetMonkPoints()		-- 0 to 4
	local points = UnitPower("player", SPELL_POWER_CHI)
	local maxPoints = UnitPowerMax("player", SPELL_POWER_CHI)

	if points > 0 and maxPoints == 4 then
		points = points + monkOffset
	end

	return points
end

local function DummyFunction()
	return nil
end


local GetPoints
local PlayerClass = select(2,UnitClassBase("player"))

if PlayerClass == "ROGUE" then
	GetPoints = GetRoguePoints
elseif PlayerClass == "DRUID" then
	GetPoints = GetDruidPoints
elseif PlayerClass == "MONK" then
	GetPoints = GetMonkPoints
elseif PlayerClass == "PALADIN" then
	--GetPoints = GetPaladinPoints
	GetPoints = DummyFunction
else
	GetPoints = DummyFunction
end

-- Update Graphics
local function UpdateWidgetFrame(frame)
		local points
		if UnitExists("target") then
			points = GetPoints()
		end

		if points and points > 0 then
			--frame.Icon:SetTexture(comboWidgetPath..tostring(points))
			frame.Icon:SetTexCoord(0, 1, grid*(points-1), grid *(points))

			--object:SetTexCoord(objectstyle.left or 0, objectstyle.right or 1, objectstyle.top or 0, objectstyle.bottom or 1)

			frame:Show()
		else frame:_Hide() end
end

-- Context
local function UpdateWidgetContext(plate, unit)

	local unitid = unit.unitid

	if UnitExists("target") and unitid == "target" then
		TidyPlatesComboWidgetFrame:SetParent(plate.widgetFrame)
	end

	--frame:_Hide()
end

local function ClearWidgetContext(frame)
	local guid = frame.guid
	if guid then
		WidgetList[guid] = nil
		frame.guid = nil
	end
end

local function OnEventHandler(frame, event, unitid)
		local guid = UnitGUID("target")
		local maxValue = UnitPowerMax("player" , 4)

		--print(event, maxValue)

--[[
		if event == "UNIT_MAXPOWER" then
			local maxValue = UnitPowerMax("player" , 4)
			--print("UNIT_MAXPOWER")

			if maxValue == 5 then

			elseif maxValue == 6 then

			elseif maxValue == 8 then

			end
		end

		if UnitExists("target") then
			local widget = WidgetList[guid]
			if widget then UpdateWidgetFrame(widget) end				-- To update all, use: for guid, widget in pairs(WidgetList) do UpdateWidgetFrame(widget) end
		end
		--]]
end

-- Widget Creation
local function CreateWidgetFrame(extended)
	--local parent = extended.widgetFrame

	-- Required Widget Code
	local frame = CreateFrame("Frame", nil, WorldFrame)
	frame:Hide()

	-- Custom Code
	frame:SetHeight(32)
	frame:SetWidth(64)

	frame.Icon = frame:CreateTexture(nil, "OVERLAY")
	frame.Icon:SetPoint("CENTER", frame, "CENTER")
	frame.Icon:SetHeight(16)
	frame.Icon:SetWidth(64)

	frame.Icon:SetTexture(artfile)

	-- Required Widget Code
	frame.UpdateContext = UpdateWidgetContext
	frame.Update = UpdateWidgetFrame
	frame._Hide = frame.Hide
	frame.Hide = function() ClearWidgetContext(frame); frame:_Hide() end

	frame:SetScript("OnEvent", OnEventHandler)
	frame:RegisterEvent("UNIT_MAXPOWER")
	frame:RegisterEvent("UNIT_COMBO_POINTS")
	frame:RegisterEvent("UNIT_POWER")
	frame:RegisterEvent("UNIT_DISPLAYPOWER")
	frame:RegisterEvent("UNIT_AURA")
	frame:RegisterEvent("UNIT_FLAGS")

	maxComboPoints = UnitPowerMax("player" , 4)		-- 4 is combo points

	return frame
end

local function CreateComboPointWidget(...)
	TidyPlatesComboWidgetFrame = TidyPlatesComboWidgetFrame or CreateWidgetFrame(...)
end


TidyPlatesWidgets.CreateComboPointWidget = CreateWidgetFrame